/**
 * @file
 * Javascript behaviors for YAML form color element integration.
 */

(function ($, Drupal) {

  'use strict';

  Drupal.behaviors.yamlFormColor = {
    attach: function (context) {
      $(context).find('.form-color').once().each(function () {
        var $element = $(this);
        // Handle browser that don't support the HTML5 color input.
        if (Modernizr.inputtypes.color === false) {
          // Remove swatch sizes.
          $element.removeClass('form-color-small')
            .removeClass('form-color-medium')
            .removeClass('form-color-large');
        }
        else {
          // Display color input's output to the end user.
          var $output = $('<input class="form-color-output ' + $element.attr('class') + ' js-yamlform-element-mask" data-inputmask-mask="\\#######" />').inputmask();
          $output[0].value = $element[0].value;
          $element
            .after($output)
            .css({float: 'left'});

          // Sync $element and $output.
          $element.on('input', function () {
            $output[0].value = $element[0].value;
          });
          $output.on('input', function () {
            $element[0].value = $output[0].value;
          });
        }
      })
    }
  };

})(jQuery, Drupal);
